/* battery.c generated by valac 0.11.7, the Vala compiler
 * generated from battery.vala, do not modify */

/*

this is a part of vattery
copyright 2011 jezra lickter http://www.jezra.net

vattery is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

vattery is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with vattery.	If not, see <http://www.gnu.org/licenses/>.

*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <glib/gstdio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_BATTERY_DATA_TYPE (battery_data_type_get_type ())

#define TYPE_BATTERY_DATA (battery_data_get_type ())
typedef struct _BatteryData BatteryData;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_BATTERY (battery_get_type ())
#define BATTERY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BATTERY, Battery))
#define BATTERY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BATTERY, BatteryClass))
#define IS_BATTERY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BATTERY))
#define IS_BATTERY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BATTERY))
#define BATTERY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BATTERY, BatteryClass))

typedef struct _Battery Battery;
typedef struct _BatteryClass BatteryClass;
typedef struct _BatteryPrivate BatteryPrivate;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
#define _g_match_info_free0(var) ((var == NULL) ? NULL : (var = (g_match_info_free (var), NULL)))
typedef struct _ParamSpecBattery ParamSpecBattery;

typedef enum  {
	BATTERY_DATA_TYPE_PROC,
	BATTERY_DATA_TYPE_SYS
} BatteryDataType;

struct _BatteryData {
	gint percent;
	gchar* state;
};

struct _Battery {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BatteryPrivate * priv;
	BatteryDataType data_type;
};

struct _BatteryClass {
	GTypeClass parent_class;
	void (*finalize) (Battery *self);
};

struct _BatteryPrivate {
	GRegex* bat_curr_regex_proc;
	GRegex* bat_tot_regex_proc;
	GRegex* ac_regex;
	gint bat_percent;
	gchar* ac_state;
};

struct _ParamSpecBattery {
	GParamSpec parent_instance;
};


static gpointer battery_parent_class = NULL;

GType battery_data_type_get_type (void) G_GNUC_CONST;
GType battery_data_get_type (void) G_GNUC_CONST;
BatteryData* battery_data_dup (const BatteryData* self);
void battery_data_free (BatteryData* self);
void battery_data_copy (const BatteryData* self, BatteryData* dest);
void battery_data_destroy (BatteryData* self);
#define DIR_PROC "/proc/acpi/battery"
#define DIR_SYS "/sys/class/power_supply"
gpointer battery_ref (gpointer instance);
void battery_unref (gpointer instance);
GParamSpec* param_spec_battery (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_battery (GValue* value, gpointer v_object);
void value_take_battery (GValue* value, gpointer v_object);
gpointer value_get_battery (const GValue* value);
GType battery_get_type (void) G_GNUC_CONST;
#define BATTERY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_BATTERY, BatteryPrivate))
enum  {
	BATTERY_DUMMY_PROPERTY
};
Battery* battery_new (void);
Battery* battery_construct (GType object_type);
void battery_check_data_type (Battery* self);
void battery_get_status (Battery* self, BatteryData* result);
static gboolean battery_get_sys_status (Battery* self);
static gboolean battery_get_proc_status (Battery* self);
static void battery_finalize (Battery* obj);


GType battery_data_type_get_type (void) {
	static volatile gsize battery_data_type_type_id__volatile = 0;
	if (g_once_init_enter (&battery_data_type_type_id__volatile)) {
		static const GEnumValue values[] = {{BATTERY_DATA_TYPE_PROC, "BATTERY_DATA_TYPE_PROC", "proc"}, {BATTERY_DATA_TYPE_SYS, "BATTERY_DATA_TYPE_SYS", "sys"}, {0, NULL, NULL}};
		GType battery_data_type_type_id;
		battery_data_type_type_id = g_enum_register_static ("BatteryDataType", values);
		g_once_init_leave (&battery_data_type_type_id__volatile, battery_data_type_type_id);
	}
	return battery_data_type_type_id__volatile;
}


void battery_data_copy (const BatteryData* self, BatteryData* dest) {
	dest->percent = self->percent;
	dest->state = g_strdup (self->state);
}


void battery_data_destroy (BatteryData* self) {
	_g_free0 ((*self).state);
}


BatteryData* battery_data_dup (const BatteryData* self) {
	BatteryData* dup;
	dup = g_new0 (BatteryData, 1);
	battery_data_copy (self, dup);
	return dup;
}


void battery_data_free (BatteryData* self) {
	battery_data_destroy (self);
	g_free (self);
}


GType battery_data_get_type (void) {
	static volatile gsize battery_data_type_id__volatile = 0;
	if (g_once_init_enter (&battery_data_type_id__volatile)) {
		GType battery_data_type_id;
		battery_data_type_id = g_boxed_type_register_static ("BatteryData", (GBoxedCopyFunc) battery_data_dup, (GBoxedFreeFunc) battery_data_free);
		g_once_init_leave (&battery_data_type_id__volatile, battery_data_type_id);
	}
	return battery_data_type_id__volatile;
}


Battery* battery_construct (GType object_type) {
	Battery* self = NULL;
	GRegex* _tmp0_ = NULL;
	GRegex* _tmp1_;
	GRegex* _tmp2_ = NULL;
	GRegex* _tmp3_;
	GRegex* _tmp4_ = NULL;
	GRegex* _tmp5_;
	GError * _inner_error_ = NULL;
	self = (Battery*) g_type_create_instance (object_type);
	_tmp0_ = g_regex_new (".*remaining.*:[ \t\n\r\f]*([0-9]*).*", G_REGEX_CASELESS, G_REGEX_MATCH_NEWLINE_ANY, &_inner_error_);
	_tmp1_ = _tmp0_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_REGEX_ERROR) {
			goto __catch10_g_regex_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_g_regex_unref0 (self->priv->bat_curr_regex_proc);
	self->priv->bat_curr_regex_proc = _tmp1_;
	goto __finally10;
	__catch10_g_regex_error:
	{
		GError * _error_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		fprintf (stdout, "%s", _error_->message);
		_g_error_free0 (_error_);
	}
	__finally10:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp2_ = g_regex_new (".*last full capacity:[ \t\n\r\f]*([0-9]*).*", G_REGEX_CASELESS, G_REGEX_MATCH_NEWLINE_ANY, &_inner_error_);
	_tmp3_ = _tmp2_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_REGEX_ERROR) {
			goto __catch11_g_regex_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_g_regex_unref0 (self->priv->bat_tot_regex_proc);
	self->priv->bat_tot_regex_proc = _tmp3_;
	goto __finally11;
	__catch11_g_regex_error:
	{
		GError * _error_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		fprintf (stdout, "%s", _error_->message);
		_g_error_free0 (_error_);
	}
	__finally11:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp4_ = g_regex_new (".*charging.*:[ \t\n\r\f]*([a-z]*).*", 0, 0, &_inner_error_);
	_tmp5_ = _tmp4_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_REGEX_ERROR) {
			goto __catch12_g_regex_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_g_regex_unref0 (self->priv->ac_regex);
	self->priv->ac_regex = _tmp5_;
	goto __finally12;
	__catch12_g_regex_error:
	{
		GError * _error_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		fprintf (stdout, "%s", _error_->message);
		_g_error_free0 (_error_);
	}
	__finally12:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	battery_check_data_type (self);
	return self;
}


Battery* battery_new (void) {
	return battery_construct (TYPE_BATTERY);
}


void battery_get_status (Battery* self, BatteryData* result) {
	BatteryData ret = {0};
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	memset (&ret, 0, sizeof (BatteryData));
	switch (self->data_type) {
		case BATTERY_DATA_TYPE_SYS:
		{
			battery_get_sys_status (self);
			break;
		}
		case BATTERY_DATA_TYPE_PROC:
		{
			battery_get_proc_status (self);
			break;
		}
		default:
		{
			break;
		}
	}
	ret.percent = self->priv->bat_percent;
	_tmp0_ = g_strdup (self->priv->ac_state);
	_g_free0 (ret.state);
	ret.state = _tmp0_;
	*result = ret;
	return;
}


void battery_check_data_type (Battery* self) {
	gchar* t = NULL;
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = battery_get_sys_status (self);
	if (_tmp0_) {
		gchar* _tmp1_;
		self->data_type = BATTERY_DATA_TYPE_SYS;
		_tmp1_ = g_strdup ("SYS");
		_g_free0 (t);
		t = _tmp1_;
	} else {
		gboolean _tmp2_;
		_tmp2_ = battery_get_proc_status (self);
		if (_tmp2_) {
			gchar* _tmp3_;
			self->data_type = BATTERY_DATA_TYPE_PROC;
			_tmp3_ = g_strdup ("PROC");
			_g_free0 (t);
			t = _tmp3_;
		} else {
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("None");
			_g_free0 (t);
			t = _tmp4_;
		}
	}
	fprintf (stdout, "using data type: %s\n", t);
	_g_free0 (t);
}


static gboolean battery_get_proc_status (Battery* self) {
	gboolean result = FALSE;
	gchar* contents = NULL;
	GMatchInfo* match_info = NULL;
	gchar* _tmp0_;
	gchar* bat_curr;
	gchar* _tmp1_;
	gchar* bat_total;
	gchar* _tmp2_;
	gchar* ac_state;
	gint bats_current;
	gint bats_total;
	gint bats_percent = 0;
	gchar* state_file = NULL;
	gchar* info_file = NULL;
	gboolean battery_data_found;
	gboolean tloop;
	GDir* _tmp3_ = NULL;
	GDir* dir;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_strdup ("");
	bat_curr = _tmp0_;
	_tmp1_ = g_strdup ("");
	bat_total = _tmp1_;
	_tmp2_ = g_strdup ("");
	ac_state = _tmp2_;
	bats_current = 0;
	bats_total = 0;
	battery_data_found = FALSE;
	tloop = TRUE;
	_tmp3_ = g_dir_open (DIR_PROC, (guint) 0, &_inner_error_);
	dir = _tmp3_;
	if (_inner_error_ != NULL) {
		goto __catch13_g_error;
	}
	g_dir_rewind (dir);
	while (TRUE) {
		const gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		gchar* name;
		if (!tloop) {
			break;
		}
		_tmp4_ = g_dir_read_name (dir);
		_tmp5_ = g_strdup (_tmp4_);
		name = _tmp5_;
		if (name == NULL) {
			tloop = FALSE;
		} else {
			gchar* _tmp6_ = NULL;
			gchar* check_path;
			gboolean _tmp7_;
			_tmp6_ = g_strdup_printf ("%s/%s", DIR_PROC, name);
			check_path = _tmp6_;
			_tmp7_ = g_file_test (check_path, G_FILE_TEST_IS_DIR);
			if (_tmp7_) {
				gchar* _tmp8_ = NULL;
				gchar* _tmp9_ = NULL;
				gboolean _tmp10_;
				_tmp8_ = g_strdup_printf ("%s/state", check_path);
				_g_free0 (state_file);
				state_file = _tmp8_;
				_tmp9_ = g_strdup_printf ("%s/info", check_path);
				_g_free0 (info_file);
				info_file = _tmp9_;
				_tmp10_ = g_file_test (state_file, G_FILE_TEST_EXISTS);
				if (_tmp10_) {
					gchar* _tmp11_ = NULL;
					gboolean _tmp12_;
					gboolean _tmp13_;
					_tmp12_ = g_file_get_contents (state_file, &_tmp11_, NULL, &_inner_error_);
					_g_free0 (contents);
					contents = _tmp11_;
					_tmp13_ = _tmp12_;
					if (_inner_error_ != NULL) {
						if (_inner_error_->domain == G_FILE_ERROR) {
							goto __catch14_g_file_error;
						}
						_g_free0 (check_path);
						_g_free0 (name);
						_g_dir_close0 (dir);
						_g_free0 (info_file);
						_g_free0 (state_file);
						_g_free0 (ac_state);
						_g_free0 (bat_total);
						_g_free0 (bat_curr);
						_g_match_info_free0 (match_info);
						_g_free0 (contents);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return FALSE;
					}
					if (_tmp13_) {
						GMatchInfo* _tmp14_ = NULL;
						gchar* _tmp15_ = NULL;
						gchar* _tmp18_ = NULL;
						gboolean _tmp19_;
						gboolean _tmp20_;
						g_regex_match (self->priv->bat_curr_regex_proc, contents, G_REGEX_MATCH_NEWLINE_ANY, &_tmp14_);
						_g_match_info_free0 (match_info);
						match_info = _tmp14_;
						_tmp15_ = g_match_info_fetch (match_info, 1);
						_g_free0 (bat_curr);
						bat_curr = _tmp15_;
						if (g_strcmp0 (ac_state, "") == 0) {
							GMatchInfo* _tmp16_ = NULL;
							gchar* _tmp17_ = NULL;
							g_regex_match (self->priv->ac_regex, contents, G_REGEX_MATCH_NEWLINE_ANY, &_tmp16_);
							_g_match_info_free0 (match_info);
							match_info = _tmp16_;
							_tmp17_ = g_match_info_fetch (match_info, 1);
							_g_free0 (ac_state);
							ac_state = _tmp17_;
						}
						_tmp19_ = g_file_get_contents (info_file, &_tmp18_, NULL, &_inner_error_);
						_g_free0 (contents);
						contents = _tmp18_;
						_tmp20_ = _tmp19_;
						if (_inner_error_ != NULL) {
							if (_inner_error_->domain == G_FILE_ERROR) {
								goto __catch14_g_file_error;
							}
							_g_free0 (check_path);
							_g_free0 (name);
							_g_dir_close0 (dir);
							_g_free0 (info_file);
							_g_free0 (state_file);
							_g_free0 (ac_state);
							_g_free0 (bat_total);
							_g_free0 (bat_curr);
							_g_match_info_free0 (match_info);
							_g_free0 (contents);
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return FALSE;
						}
						if (_tmp20_) {
							GMatchInfo* _tmp21_ = NULL;
							gchar* _tmp22_ = NULL;
							gint _tmp23_;
							gint _tmp24_;
							g_regex_match (self->priv->bat_tot_regex_proc, contents, G_REGEX_MATCH_NEWLINE_ANY, &_tmp21_);
							_g_match_info_free0 (match_info);
							match_info = _tmp21_;
							_tmp22_ = g_match_info_fetch (match_info, 1);
							_g_free0 (bat_total);
							bat_total = _tmp22_;
							battery_data_found = TRUE;
							_tmp23_ = atoi (bat_curr);
							bats_current = bats_current + _tmp23_;
							_tmp24_ = atoi (bat_total);
							bats_total = bats_total + _tmp24_;
						}
					}
					goto __finally14;
					__catch14_g_file_error:
					{
						GError * _error_;
						_error_ = _inner_error_;
						_inner_error_ = NULL;
						_g_error_free0 (_error_);
					}
					__finally14:
					if (_inner_error_ != NULL) {
						_g_free0 (check_path);
						_g_free0 (name);
						_g_dir_close0 (dir);
						goto __catch13_g_error;
					}
				}
			}
			_g_free0 (check_path);
		}
		_g_free0 (name);
	}
	_g_dir_close0 (dir);
	goto __finally13;
	__catch13_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		fprintf (stdout, "%s", e->message);
		_g_error_free0 (e);
	}
	__finally13:
	if (_inner_error_ != NULL) {
		_g_free0 (info_file);
		_g_free0 (state_file);
		_g_free0 (ac_state);
		_g_free0 (bat_total);
		_g_free0 (bat_curr);
		_g_match_info_free0 (match_info);
		_g_free0 (contents);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	if (battery_data_found) {
		gchar* _tmp25_;
		bats_percent = (bats_current * 100) / bats_total;
		self->priv->bat_percent = bats_percent;
		_tmp25_ = g_strdup (ac_state);
		_g_free0 (self->priv->ac_state);
		self->priv->ac_state = _tmp25_;
	} else {
		gchar* _tmp26_;
		self->priv->bat_percent = 0;
		_tmp26_ = g_strdup ("NONE");
		_g_free0 (self->priv->ac_state);
		self->priv->ac_state = _tmp26_;
		result = FALSE;
		_g_free0 (info_file);
		_g_free0 (state_file);
		_g_free0 (ac_state);
		_g_free0 (bat_total);
		_g_free0 (bat_curr);
		_g_match_info_free0 (match_info);
		_g_free0 (contents);
		return result;
	}
	result = TRUE;
	_g_free0 (info_file);
	_g_free0 (state_file);
	_g_free0 (ac_state);
	_g_free0 (bat_total);
	_g_free0 (bat_curr);
	_g_match_info_free0 (match_info);
	_g_free0 (contents);
	return result;
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}


static gboolean battery_get_sys_status (Battery* self) {
	gboolean result = FALSE;
	gchar* contents = NULL;
	gchar* _tmp0_;
	gchar* bat_curr;
	gchar* _tmp1_;
	gchar* bat_total;
	gchar* _tmp2_;
	gchar* ac_state;
	gint bats_current;
	gint bats_total;
	gint bats_percent = 0;
	gchar* status_file = NULL;
	gchar* charge_full_file = NULL;
	gchar* charge_now_file = NULL;
	gboolean battery_data_found;
	gboolean tloop;
	GDir* _tmp3_ = NULL;
	GDir* dir;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_strdup ("");
	bat_curr = _tmp0_;
	_tmp1_ = g_strdup ("");
	bat_total = _tmp1_;
	_tmp2_ = g_strdup ("");
	ac_state = _tmp2_;
	bats_current = 0;
	bats_total = 0;
	battery_data_found = FALSE;
	tloop = TRUE;
	_tmp3_ = g_dir_open (DIR_SYS, (guint) 0, &_inner_error_);
	dir = _tmp3_;
	if (_inner_error_ != NULL) {
		goto __catch15_g_error;
	}
	g_dir_rewind (dir);
	while (TRUE) {
		const gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		gchar* name;
		if (!tloop) {
			break;
		}
		_tmp4_ = g_dir_read_name (dir);
		_tmp5_ = g_strdup (_tmp4_);
		name = _tmp5_;
		if (name == NULL) {
			tloop = FALSE;
		} else {
			gboolean _tmp6_;
			gchar* _tmp7_ = NULL;
			gchar* check_path;
			gboolean _tmp8_;
			_tmp6_ = g_str_has_prefix (name, "BAT");
			if (!_tmp6_) {
				_g_free0 (name);
				continue;
			}
			_tmp7_ = g_strdup_printf ("%s/%s", DIR_SYS, name);
			check_path = _tmp7_;
			_tmp8_ = g_file_test (check_path, G_FILE_TEST_IS_DIR);
			if (_tmp8_) {
				gchar* _tmp9_ = NULL;
				gchar* _tmp10_ = NULL;
				gchar* _tmp11_ = NULL;
				gboolean _tmp12_;
				_tmp9_ = g_strdup_printf ("%s/status", check_path);
				_g_free0 (status_file);
				status_file = _tmp9_;
				_tmp10_ = g_strdup_printf ("%s/charge_full", check_path);
				_g_free0 (charge_full_file);
				charge_full_file = _tmp10_;
				_tmp11_ = g_strdup_printf ("%s/charge_now", check_path);
				_g_free0 (charge_now_file);
				charge_now_file = _tmp11_;
				_tmp12_ = g_file_test (charge_now_file, G_FILE_TEST_EXISTS);
				if (_tmp12_) {
					gchar* _tmp13_ = NULL;
					gboolean _tmp14_;
					gboolean _tmp15_;
					_tmp14_ = g_file_get_contents (charge_now_file, &_tmp13_, NULL, &_inner_error_);
					_g_free0 (contents);
					contents = _tmp13_;
					_tmp15_ = _tmp14_;
					if (_inner_error_ != NULL) {
						if (_inner_error_->domain == G_FILE_ERROR) {
							goto __catch16_g_file_error;
						}
						_g_free0 (check_path);
						_g_free0 (name);
						_g_dir_close0 (dir);
						_g_free0 (charge_now_file);
						_g_free0 (charge_full_file);
						_g_free0 (status_file);
						_g_free0 (ac_state);
						_g_free0 (bat_total);
						_g_free0 (bat_curr);
						_g_free0 (contents);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return FALSE;
					}
					if (_tmp15_) {
						gchar* _tmp16_;
						gchar* _tmp17_ = NULL;
						gboolean _tmp18_;
						gboolean _tmp19_;
						gchar* _tmp23_ = NULL;
						gboolean _tmp24_;
						gboolean _tmp25_;
						_tmp16_ = g_strdup (contents);
						_g_free0 (bat_curr);
						bat_curr = _tmp16_;
						_tmp18_ = g_file_get_contents (charge_full_file, &_tmp17_, NULL, &_inner_error_);
						_g_free0 (contents);
						contents = _tmp17_;
						_tmp19_ = _tmp18_;
						if (_inner_error_ != NULL) {
							if (_inner_error_->domain == G_FILE_ERROR) {
								goto __catch16_g_file_error;
							}
							_g_free0 (check_path);
							_g_free0 (name);
							_g_dir_close0 (dir);
							_g_free0 (charge_now_file);
							_g_free0 (charge_full_file);
							_g_free0 (status_file);
							_g_free0 (ac_state);
							_g_free0 (bat_total);
							_g_free0 (bat_curr);
							_g_free0 (contents);
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return FALSE;
						}
						if (_tmp19_) {
							gchar* _tmp20_;
							gint _tmp21_;
							gint _tmp22_;
							_tmp20_ = g_strdup (contents);
							_g_free0 (bat_total);
							bat_total = _tmp20_;
							battery_data_found = TRUE;
							_tmp21_ = atoi (bat_curr);
							bats_current = bats_current + _tmp21_;
							_tmp22_ = atoi (bat_total);
							bats_total = bats_total + _tmp22_;
						}
						_tmp24_ = g_file_get_contents (status_file, &_tmp23_, NULL, &_inner_error_);
						_g_free0 (contents);
						contents = _tmp23_;
						_tmp25_ = _tmp24_;
						if (_inner_error_ != NULL) {
							if (_inner_error_->domain == G_FILE_ERROR) {
								goto __catch16_g_file_error;
							}
							_g_free0 (check_path);
							_g_free0 (name);
							_g_dir_close0 (dir);
							_g_free0 (charge_now_file);
							_g_free0 (charge_full_file);
							_g_free0 (status_file);
							_g_free0 (ac_state);
							_g_free0 (bat_total);
							_g_free0 (bat_curr);
							_g_free0 (contents);
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return FALSE;
						}
						if (_tmp25_) {
							gchar* _tmp26_ = NULL;
							gchar* _tmp27_;
							gchar* _tmp28_ = NULL;
							_tmp26_ = string_strip (contents);
							_tmp27_ = _tmp26_;
							_tmp28_ = g_utf8_strdown (_tmp27_, (gssize) (-1));
							_g_free0 (ac_state);
							ac_state = _tmp28_;
							_g_free0 (_tmp27_);
						}
					}
					goto __finally16;
					__catch16_g_file_error:
					{
						GError * _error_;
						_error_ = _inner_error_;
						_inner_error_ = NULL;
						_g_error_free0 (_error_);
					}
					__finally16:
					if (_inner_error_ != NULL) {
						_g_free0 (check_path);
						_g_free0 (name);
						_g_dir_close0 (dir);
						goto __catch15_g_error;
					}
				}
			}
			_g_free0 (check_path);
		}
		_g_free0 (name);
	}
	_g_dir_close0 (dir);
	goto __finally15;
	__catch15_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		fprintf (stdout, "%s", e->message);
		_g_error_free0 (e);
	}
	__finally15:
	if (_inner_error_ != NULL) {
		_g_free0 (charge_now_file);
		_g_free0 (charge_full_file);
		_g_free0 (status_file);
		_g_free0 (ac_state);
		_g_free0 (bat_total);
		_g_free0 (bat_curr);
		_g_free0 (contents);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	if (battery_data_found) {
		gchar* _tmp29_;
		bats_percent = (bats_current * 100) / bats_total;
		self->priv->bat_percent = bats_percent;
		_tmp29_ = g_strdup (ac_state);
		_g_free0 (self->priv->ac_state);
		self->priv->ac_state = _tmp29_;
	} else {
		gchar* _tmp30_;
		self->priv->bat_percent = 0;
		_tmp30_ = g_strdup ("NONE");
		_g_free0 (self->priv->ac_state);
		self->priv->ac_state = _tmp30_;
		result = FALSE;
		_g_free0 (charge_now_file);
		_g_free0 (charge_full_file);
		_g_free0 (status_file);
		_g_free0 (ac_state);
		_g_free0 (bat_total);
		_g_free0 (bat_curr);
		_g_free0 (contents);
		return result;
	}
	result = TRUE;
	_g_free0 (charge_now_file);
	_g_free0 (charge_full_file);
	_g_free0 (status_file);
	_g_free0 (ac_state);
	_g_free0 (bat_total);
	_g_free0 (bat_curr);
	_g_free0 (contents);
	return result;
}


static void value_battery_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_battery_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		battery_unref (value->data[0].v_pointer);
	}
}


static void value_battery_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = battery_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_battery_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_battery_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		Battery* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = battery_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_battery_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	Battery** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = battery_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_battery (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecBattery* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_BATTERY), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_battery (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BATTERY), NULL);
	return value->data[0].v_pointer;
}


void value_set_battery (GValue* value, gpointer v_object) {
	Battery* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BATTERY));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BATTERY));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		battery_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		battery_unref (old);
	}
}


void value_take_battery (GValue* value, gpointer v_object) {
	Battery* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BATTERY));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BATTERY));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		battery_unref (old);
	}
}


static void battery_class_init (BatteryClass * klass) {
	battery_parent_class = g_type_class_peek_parent (klass);
	BATTERY_CLASS (klass)->finalize = battery_finalize;
	g_type_class_add_private (klass, sizeof (BatteryPrivate));
}


static void battery_instance_init (Battery * self) {
	self->priv = BATTERY_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void battery_finalize (Battery* obj) {
	Battery * self;
	self = BATTERY (obj);
	_g_regex_unref0 (self->priv->bat_curr_regex_proc);
	_g_regex_unref0 (self->priv->bat_tot_regex_proc);
	_g_regex_unref0 (self->priv->ac_regex);
	_g_free0 (self->priv->ac_state);
}


GType battery_get_type (void) {
	static volatile gsize battery_type_id__volatile = 0;
	if (g_once_init_enter (&battery_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_battery_init, value_battery_free_value, value_battery_copy_value, value_battery_peek_pointer, "p", value_battery_collect_value, "p", value_battery_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (BatteryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) battery_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Battery), 0, (GInstanceInitFunc) battery_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType battery_type_id;
		battery_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Battery", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&battery_type_id__volatile, battery_type_id);
	}
	return battery_type_id__volatile;
}


gpointer battery_ref (gpointer instance) {
	Battery* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void battery_unref (gpointer instance) {
	Battery* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		BATTERY_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



